<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 11/28/2004 *
 * ===================                          Last change: 11/28/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : load_cache.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Load more cache files                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mehr Cache-Dateien nachladen                     *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2013 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Init cache instance and array
$GLOBALS['cache_instance'] = NULL;

// Init cache first
initCacheInstance();

// Init variables
initExtensionCssFiles();

// Initialize array for "always keep active extensions"
$GLOBALS['cache_array']['always_active'] = array();

// Init & set the INC_POOL
initIncludePool('cache');
setIncludePool('cache', getArrayFromDirectory('inc/loader/', 'load-'));

// Pre-load filter cacher
loadIncludeOnce('inc/loader/load-filter.php');

// Pre-load extensions cacher
loadIncludeOnce('inc/loader/load-extension.php');

// Load all includes
loadIncludePool('cache');

// Init filter system
initFilterSystem();

// Init system here
runFilterChain('init');

// Run post-initialization (e.g. determining username)
runFilterChain('post_init');

// [EOF]
?>
